/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

scr48	= %00111111	;screen 48b
scr40	= %00111110	;screen 40b
scr32	= %00111101	;screen 32b

hposp0	= $D000
hposp1	= $D001
hposp2	= $D002
hposp3	= $D003
hposm0	= $D004
hposm1	= $D005
hposm2	= $D006
hposm3	= $D007
sizep0	= $D008
sizep1	= $D009
sizep2	= $D00A
sizep3	= $D00B
sizem	= $D00C

colpm0	= $D012
colpm1	= $D013
colpm2	= $D014
colpm3	= $D015
color0	= $D016
color1	= $D017
color2	= $D018
color3	= $D019
colbak	= $D01A
gtictl	= $D01B

pmcntl	= $D01D
hitclr	= $D01E

skctl	= $D20F

portb	= $D301

dmactl	= $D400

dlptr	= $D402

pmbase	= $D407

chbase	= $D409
wsync	= $D40A
vcount	= $D40B

nmien	= $D40E
nmist	= $D40F


	org $00

fcnt	.ds 2
fadr	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

	.ifdef ZCOLORS
zc	.ds ZCOLORS
	eif


* ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

* ---	MAIN PROGRAM
	org $2000

;ant	ANTIC_PROGRAM scr,ant

scr	SCREEN_DATA
;	org $6000

	.ALIGN $0400
fnt	FONTS

	.ifdef USESPRITES
	.ALIGN $0800
	.ds $0300
pmg	SPRITES
	eif


ant 
gr_adr equ *+1
 dta $54,a(scr)
gr_adr1 equ *+1
 dta $d4,a(scr+96)
gr_adr2 equ *+1
 dta $54,a(scr)
gr_adr3 equ *+1
 dta $d4,a(scr+96)
gr_adr4 equ *+1
 dta $54,a(scr)
gr_adr5 equ *+1
 dta $d4,a(scr+96)
gr_adr6 equ *+1
 dta $54,a(scr)
gr_adr7 equ *+1
 dta $d4,a(scr+96)
gr_adr8 equ *+1
 dta $54,a(scr)
gr_adr9 equ *+1
 dta $d4,a(scr+96)
gr_adr10 equ *+1
 dta $54,a(scr)
gr_adr11 equ *+1
 dta $d4,a(scr+96)
gr_adr12 equ *+1
 dta $54,a(scr)
gr_adr13 equ *+1
 dta $d4,a(scr+96)
gr_adr14 equ *+1
 dta $54,a(scr)
gr_adr15 equ *+1
 dta $d4,a(scr+96)
gr_adr16 equ *+1
 dta $54,a(scr)
gr_adr17 equ *+1
 dta $d4,a(scr+96)
gr_adr18 equ *+1
 dta $54,a(scr)
gr_adr19 equ *+1
 dta $d4,a(scr+96)
gr_adr20 equ *+1
 dta $54,a(scr)
gr_adr21 equ *+1
 dta $d4,a(scr+96)
gr_adr22 equ *+1
 dta $54,a(scr)
gr_adr23 equ *+1
 dta $d4,a(scr+96)
gr_adr24 equ *+1
 dta $54,a(scr)
gr_adr25 equ *+1
 dta $d4,a(scr+96)
gr_adr26 equ *+1
 dta $54,a(scr)
gr_adr27 equ *+1
 dta $d4,a(scr+96)
gr_adr28 equ *+1
 dta $54,a(scr)
gr_adr29 equ *+1
 dta $d4,a(scr+96)
 dta $41,a(ant)

hscrol    dta 0
licznik   .byte $30 
 

main
* ---	init PMG

	.ifdef USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	.ifdef CHANGES		;if label CHANGES defined
	jsr save_color		;then save all colors and set value 0 for all colors
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again


	.ifdef CHANGES		;if label CHANGES defined

	jsr fade_in		;fade in colors
_lp	lda skctl		;wait to press any key; here you can put any own routine
	and #$04
	bne _lp
	jsr fade_out		;fade out colors
	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+
	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled
	jmp ($000a)		;jump to DOS

	els

null	jmp dli1		;CPU is busy here, so no more routines allowed

	eif


* ---	DLI PROGRAM

	?old_dli = *

dli1
	lda vcount
	cmp #$02
	bne dli1
	:3 sta wsync
	DLINEW dli2
dli_start


dli2
	lda >fnt+$400*$01
	sta wsync		;line=16
	sta chbase
	DLINEW dli3

dli3
	lda >fnt+$400*$02
	sta wsync		;line=32
	sta chbase
	DLINEW dli4

dli4
	lda >fnt+$400*$03
	sta wsync		;line=48
	sta chbase
	DLINEW dli5

dli5
	lda >fnt+$400*$04
	sta wsync		;line=64
	sta chbase
	DLINEW dli6

dli6
	lda >fnt+$400*$05
	sta wsync		;line=80
	sta chbase
	DLINEW dli7

dli7
	lda >fnt+$400*$06
	sta wsync		;line=96
	sta chbase
	DLINEW dli8

dli8
	lda >fnt+$400*$07
	sta wsync		;line=112
	sta chbase
	DLINEW dli9

dli9
	lda >fnt+$400*$08
	sta wsync		;line=128
	sta chbase
	DLINEW dli10

dli10
	lda >fnt+$400*$09
	sta wsync		;line=144
	sta chbase
	DLINEW dli11

dli11
	lda >fnt+$400*$0A
	sta wsync		;line=160
	sta chbase
	DLINEW dli12

dli12
	lda >fnt+$400*$0B
	sta wsync		;line=176
	sta chbase
	DLINEW dli13

dli13
	lda >fnt+$400*$0C
	sta wsync		;line=192
	sta chbase
	DLINEW dli14

dli14
	lda >fnt+$400*$0D
	sta wsync		;line=208
	sta chbase
	DLINEW dli15

dli15
	lda >fnt+$400*$0E
	sta wsync		;line=224
	sta chbase
	jmp NMI.quit

;---

CHANGES

;---

.proc	NMI
	sta regA
	stx regX
	sty regY

	bit nmist
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta nmist		;reset NMI flag

	inc cloc		;little timer

	mwa #ant dlptr		;ANTIC address program

	mva #scr48 dmactl	;set new screen's width

;--- first line of screen initialization

;KOLORY
	lda >fnt+$400*$00
	sta chbase
c0	lda #$00
	sta colbak
c1	lda #$14
	sta color0
c2	lda #$16
	sta color1
c3	lda #$1A
	sta color2
	sta color3
	lda #$04
	sta gtictl

	mwa #dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

 jsr prog

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

;---
	icl 'scroll.fad'

	run main

prog    equ $8800

    org prog


    ldx hscrol        ; pobierz stara wartosc hscrol
    bne cont
next_char
    ldy licznik
    beq n
    dey 
    sty licznik
    inc gr_adr        ; przesun tekst o cay znak
    inc gr_adr1       ; przesun tekst o cay znak
    inc gr_adr2       ; przesun tekst o cay znak
    inc gr_adr3       ; przesun tekst o cay znak
    inc gr_adr4       ; przesun tekst o cay znak
    inc gr_adr5       ; przesun tekst o cay znak
    inc gr_adr6       ; przesun tekst o cay znak
    inc gr_adr7       ; przesun tekst o cay znak
    inc gr_adr8       ; przesun tekst o cay znak
    inc gr_adr9       ; przesun tekst o cay znak
    inc gr_adr10       ; przesun tekst o cay znak
    inc gr_adr11       ; przesun tekst o cay znak
    inc gr_adr12       ; przesun tekst o cay znak
    inc gr_adr13       ; przesun tekst o cay znak
    inc gr_adr14       ; przesun tekst o cay znak
    inc gr_adr15       ; przesun tekst o cay znak
    inc gr_adr16       ; przesun tekst o cay znak
    inc gr_adr17       ; przesun tekst o cay znak
    inc gr_adr18       ; przesun tekst o cay znak
    inc gr_adr19       ; przesun tekst o cay znak
    inc gr_adr20       ; przesun tekst o cay znak
    inc gr_adr21       ; przesun tekst o cay znak
    inc gr_adr22       ; przesun tekst o cay znak
    inc gr_adr23       ; przesun tekst o cay znak
    inc gr_adr24       ; przesun tekst o cay znak
    inc gr_adr25       ; przesun tekst o cay znak
    inc gr_adr26       ; przesun tekst o cay znak
    inc gr_adr27       ; przesun tekst o cay znak
    inc gr_adr28       ; przesun tekst o cay znak
    inc gr_adr29       ; przesun tekst o cay znak

;PRDKO SCROLLA (1,2,4)

    ldx #4            ; nowy hscrol
cont
    dex
    stx hscrol        ; zapamietaj nowa wartosc hscrol
    stx $d404         ; i zapisz do rejestru 
    jmp rts
n
    ldy #48
    sty licznik    

    ldy #$00
    sty gr_adr
    ldy #$60
    sty gr_adr1
    ldy #$00
    sty gr_adr2
    ldy #$60
    sty gr_adr3
    ldy #$00
    sty gr_adr4
    ldy #$60
    sty gr_adr5
    ldy #$00
    sty gr_adr6
    ldy #$60
    sty gr_adr7
    ldy #$00
    sty gr_adr8
    ldy #$60
    sty gr_adr9
    ldy #$00
    sty gr_adr10
    ldy #$60
    sty gr_adr11
    ldy #$00
    sty gr_adr12
    ldy #$60
    sty gr_adr13
    ldy #$00
    sty gr_adr14
    ldy #$60
    sty gr_adr15
    ldy #$00
    sty gr_adr16
    ldy #$60
    sty gr_adr17
    ldy #$00
    sty gr_adr18
    ldy #$60
    sty gr_adr19
    ldy #$00
    sty gr_adr20
    ldy #$60
    sty gr_adr21
    ldy #$00
    sty gr_adr22
    ldy #$60
    sty gr_adr23
    ldy #$00
    sty gr_adr24
    ldy #$60
    sty gr_adr25
    ldy #$00
    sty gr_adr26
    ldy #$60
    sty gr_adr27
    ldy #$00
    sty gr_adr28
    ldy #$60
    sty gr_adr29
rts    
    rts    

;---

	opt l-

.MACRO	SPRITES
	.ds $100
	.ds $100
	.ds $100
	.ds $100
	.ds $100
.ENDM

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	jmp NMI.quit

	.def ?old_dli = *
.ENDM

;.MACRO	ANTIC_PROGRAM
;	dta $44,a(:1),$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84
;	dta $04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$84,$04,$04
;	dta $41,a(:2)
.ENDM

.MACRO	SCREEN_DATA
	ins 'scroll.scr'
.ENDM

.MACRO	FONTS
	ins 'scroll.fnt'
.ENDM
